import { Bot as BotServer } from './Bot';
var botServer;
var Bot = (function () {
    function Bot(options) {
        botServer = new BotServer(options);
        this.server = undefined;
        Reflect.defineProperty(this, 'server', {
            configurable: false,
            enumerable: true,
            get: function () { return botServer.server; },
        });
        this.perMessageDeflate = undefined;
        Reflect.defineProperty(this, 'perMessageDeflate', {
            configurable: false,
            enumerable: true,
            get: function () { return botServer.perMessageDeflate; },
        });
        this.leaveOnceAlone = undefined;
        Reflect.defineProperty(this, 'leaveOnceAlone', {
            configurable: false,
            enumerable: true,
            get: function () { return botServer.leaveOnceAlone; },
        });
        this.webGroups = undefined;
        Reflect.defineProperty(this, 'webGroups', {
            configurable: false,
            enumerable: true,
            get: function () { return botServer.webGroups; },
        });
        this.url = undefined;
        Reflect.defineProperty(this, 'url', {
            configurable: false,
            enumerable: true,
            get: function () { return botServer.url; },
        });
        this.onWebGroup = undefined;
        Reflect.defineProperty(this, 'onWebGroup', {
            configurable: true,
            enumerable: true,
            get: function () { return (botServer.onWebGroup.name === 'none' ? undefined : botServer.onWebGroup); },
            set: function (handler) {
                if (typeof handler !== 'function') {
                    botServer.onWebGroup = function none() { };
                }
                else {
                    botServer.onWebGroup = handler;
                }
            },
        });
        this.onError = undefined;
        Reflect.defineProperty(this, 'onError', {
            configurable: true,
            enumerable: true,
            get: function () { return (botServer.onError.name === 'none' ? undefined : botServer.onError); },
            set: function (handler) {
                if (typeof handler !== 'function') {
                    botServer.onError = function none() { };
                }
                else {
                    botServer.onError = handler;
                }
            },
        });
    }
    return Bot;
}());
export { Bot };
//# sourceMappingURL=BotFacade.js.map