import { IMessage } from './proto';
import { WebChannel } from './WebChannel';
export declare enum ChannelType {
    INTERNAL = 0,
    INVITED = 1,
    JOINING = 2,
}
export interface IChannelInitData {
    members: number[];
}
export declare const MAXIMUM_MISSED_HEARTBEAT = 3;
export declare class Channel {
    id: number;
    send: (data: Uint8Array) => void;
    type: ChannelType;
    missedHeartbeat: number;
    init: Promise<void>;
    initData: IChannelInitData | undefined;
    private wsOrDc;
    private rtcPeerConnection;
    private wc;
    private heartbeatMsg;
    private resolveInit;
    constructor(wc: WebChannel, wsOrDc: WebSocket | RTCDataChannel, type: ChannelType, id?: number, rtcPeerConnection?: RTCPeerConnection);
    readonly url: string;
    encodeAndSend({senderId, recipientId, serviceId, content}?: IMessage): void;
    close(): void;
    sendHeartbeat(): void;
    private sendInBrowser(data);
    private sendInNodeOverWebSocket(data);
    private sendInNodeOverDataChannel(data);
    private handleInitMessage(msg);
    private initHandlers();
    private createHeartbeatMsg();
    private sendInitPing();
}
