var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { BehaviorSubject, Subject } from 'rxjs';
import { Channel, ChannelType } from './Channel';
import { isURL } from './misc/util';
export var CONNECT_TIMEOUT = 4000;
export var Route;
(function (Route) {
    Route["JOIN"] = "join";
    Route["INVITE"] = "invite";
    Route["INTERNAL"] = "internal";
})(Route || (Route = {}));
var WebSocketBuilder = (function () {
    function WebSocketBuilder(wc) {
        this.wc = wc;
        this.channelsSubject = new Subject();
    }
    WebSocketBuilder.prototype.onChannel = function () {
        return this.channelsSubject.asObservable();
    };
    WebSocketBuilder.prototype.connectToInvite = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var fullUrl, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(isURL(url) && url.search(/^wss?/) !== -1)) return [3, 2];
                        fullUrl = this.composeUrl(url, Route.INVITE);
                        _b = (_a = this.channelsSubject).next;
                        return [4, this.connect(fullUrl, ChannelType.INVITED)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [3, 3];
                    case 2: throw new Error("Invalid URL format: " + url);
                    case 3: return [2];
                }
            });
        });
    };
    WebSocketBuilder.prototype.newInviteWebSocket = function (ws) {
        this.channelsSubject.next(new Channel(this.wc, ws, ChannelType.JOINING));
    };
    WebSocketBuilder.prototype.connectToJoin = function (url, wcId) {
        return __awaiter(this, void 0, void 0, function () {
            var fullUrl, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(isURL(url) && url.search(/^wss?/) !== -1)) return [3, 2];
                        fullUrl = this.composeUrl(url, Route.JOIN, wcId);
                        _b = (_a = this.channelsSubject).next;
                        return [4, this.connect(fullUrl, ChannelType.JOINING)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [3, 3];
                    case 2: throw new Error("Invalid URL format: " + url);
                    case 3: return [2];
                }
            });
        });
    };
    WebSocketBuilder.prototype.newJoinWebSocket = function (ws) {
        this.channelsSubject.next(new Channel(this.wc, ws, ChannelType.INVITED));
    };
    WebSocketBuilder.prototype.connectInternal = function (url, id) {
        return __awaiter(this, void 0, void 0, function () {
            var fullUrl, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(isURL(url) && url.search(/^wss?/) !== -1)) return [3, 2];
                        fullUrl = this.composeUrl(url, Route.INTERNAL);
                        _b = (_a = this.channelsSubject).next;
                        return [4, this.connect(fullUrl, ChannelType.INTERNAL, id)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [3, 3];
                    case 2: throw new Error("Invalid URL format: " + url);
                    case 3: return [2];
                }
            });
        });
    };
    WebSocketBuilder.prototype.newInternalWebSocket = function (ws, id) {
        this.channelsSubject.next(new Channel(this.wc, ws, ChannelType.INTERNAL, id));
    };
    WebSocketBuilder.prototype.connect = function (url, type, id) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var ws;
            return __generator(this, function (_a) {
                if (isURL(url) && url.search(/^wss?/) !== -1) {
                }
                else {
                    throw new Error(url + " is not a valid URL");
                }
                ws = new global.WebSocket(url);
                return [2, new Promise(function (resolve, reject) {
                        var timeout = setTimeout(function () {
                            if (ws.readyState !== ws.OPEN) {
                                ws.close();
                                reject(new Error("WebSocket " + CONNECT_TIMEOUT + "ms connection timeout with '" + url + "'"));
                            }
                        }, CONNECT_TIMEOUT);
                        ws.onopen = function () {
                            var channel = new Channel(_this.wc, ws, type, id);
                            clearTimeout(timeout);
                            resolve(channel);
                        };
                        ws.onerror = function (err) { return reject(err); };
                        ws.onclose = function (closeEvt) {
                            reject(new Error("WebSocket connection to '" + url + "' failed with code " + closeEvt.code + ": " + closeEvt.reason));
                        };
                    })];
            });
        });
    };
    WebSocketBuilder.prototype.composeUrl = function (url, route, wcId) {
        if (wcId === void 0) { wcId = this.wc.id; }
        if (route === Route.INTERNAL) {
            return url + "/" + route + "?wcId=" + wcId + "&senderId=" + this.wc.myId;
        }
        else {
            return url + "/" + route + "?wcId=" + wcId + "&key=" + this.wc.key;
        }
    };
    WebSocketBuilder.listenUrl = new BehaviorSubject('');
    return WebSocketBuilder;
}());
export { WebSocketBuilder };
//# sourceMappingURL=WebSocketBuilder.js.map