import { Observable } from 'rxjs';
import { Channel } from '../../Channel';
import { channelBuilder as proto } from '../../proto';
import { WebChannel } from '../../WebChannel';
import { Service } from '../Service';
export declare class ChannelBuilder extends Service<proto.IMessage, proto.Message> {
    static readonly SERVICE_ID: number;
    private static pingEncoded;
    private static pongEncoded;
    private pairEncoded;
    private allStreams;
    private wc;
    private dataChannelBuilder;
    private channelsSubject;
    private pendingReqs;
    private myInfo;
    private pingTimeout;
    constructor(wc: WebChannel);
    clean(): void;
    readonly onChannel: Observable<Channel>;
    connectOverWebChannel(id: number): Promise<void>;
    connectOverSignaling(): Promise<void>;
    private ping(id, streamId?);
    private handleMessage(streamId, senderId, msg);
    private proceedAlgo(streamId, initiator, passive, amIInitiator);
    private tryWs(streamId, me, theOther, amIInitiator);
    private tryDc(streamId, me, theOther, amIInitiator);
    private handlePong(streamId, id);
    private encodePingPong();
    private subscribeToChannels();
    private subscribeToURLandIDChange();
}
