export interface IPendingRequest {
    created: number;
    promise: Promise<void> | undefined;
    resolve: () => void;
    reject: (err: Error) => void;
}
export declare class PendingRequests {
    private wcReqs;
    private sigReqs;
    private wcStreamId;
    constructor(wcStreamId: number);
    add(streamId: number, id: number, timeout: number): IPendingRequest;
    addPing(streamId: number, id: number, timeout: number): IPendingRequest;
    get(streamId: number, id: number): IPendingRequest | undefined;
    getPing(streamId: number, id: number): IPendingRequest | undefined;
    getCreatedDate(streamId: number, id: number): number | undefined;
    clean(): void;
    private cleanAll(requests);
    private getReqsByStreamId(streamId);
    private addRequest(requests, id, timeout);
}
