var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Subject } from 'rxjs';
import { Service } from '../Service';
export var TopologyEnum;
(function (TopologyEnum) {
    TopologyEnum[TopologyEnum["FULL_MESH"] = 0] = "FULL_MESH";
})(TopologyEnum || (TopologyEnum = {}));
export var TopologyState;
(function (TopologyState) {
    TopologyState[TopologyState["JOINING"] = 0] = "JOINING";
    TopologyState[TopologyState["JOINED"] = 1] = "JOINED";
    TopologyState[TopologyState["LEFT"] = 2] = "LEFT";
})(TopologyState || (TopologyState = {}));
var Topology = (function (_super) {
    __extends(Topology, _super);
    function Topology(wc, serviceId, proto) {
        var _this = _super.call(this, serviceId, proto) || this;
        _this.wc = wc;
        _this.wcStream = _super.prototype.useWebChannelStream.call(_this, wc);
        _this.stateSubject = new Subject();
        _this._state = TopologyState.LEFT;
        return _this;
    }
    Object.defineProperty(Topology.prototype, "onState", {
        get: function () {
            return this.stateSubject.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Topology.prototype, "state", {
        get: function () {
            return this._state;
        },
        enumerable: true,
        configurable: true
    });
    Topology.prototype.setJoinedState = function () {
        this.setState(TopologyState.JOINED);
    };
    Topology.prototype.setLeftState = function () {
        this.setState(TopologyState.LEFT);
    };
    Topology.prototype.setState = function (state) {
        if (this.state !== state) {
            this._state = state;
            this.stateSubject.next(state);
        }
    };
    return Topology;
}(Service));
export { Topology };
//# sourceMappingURL=Topology.js.map